﻿using AIOUSBNet;  // namespace exposes AIOUSB Class interface
using System;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;

namespace Sample1
{
    public partial class ConsoleTestResultsForm : Form
    {
        public ConsoleTestResultsForm()
        {
            InitializeComponent();
        }

        private void ConsoleTestResultsForm2_Load(object sender, EventArgs e)
        {
            Trace.WriteLine("BEGIN ConsoleTestResultsForm2_Load()");
            Trace.Indent();
            // Display Software Version
            labelSoftware_Version.Text = gv.SOFTWARE_VERSION;

            // Check for V_BADGE_ACCESS
            if (gv.BADGE_ACCESS.Contains("Supervisor")) // Enable Manual Option Selection Keys on the touch screen . Must Default to non Supervisor after Cycle Complete
            {
                Trace.WriteLine("Supervisor Badge Detected");
            }
            else // // Disable Manual Option Selection Keys on the touch screen
            {
                Trace.WriteLine("Starting Timer");
                timer1.Start(); 
            }

            // CONSOLE MANIFEST - Highline (default)                                                          ,3002,            ,4301,             ,402,
        
            //Manifest_Options_old.Text = "0000000355149,103xxxxxxxxxx,0000004364960,13525890FT12,1502,13529874FW86,3000,13529875FW85,4300,135619101FT06,400,13592451FT45,1302,85117464FT09,1101,84638621GO2A,2701,13592452FW74,3501,84952174FW83,4201,84786104FW68,3101,84960563M33V,3301,13537143M08L,2901,";



            // PARSE OUT THE CSN #
            //gv.CSN = Manifest_Options.Text.Substring(28, 13);

            PLC.Results.CSN = gv.ConsoleTestMainForm.ManifestData.CSN;
            textBoxfrm2VIN.Text = PLC.Results.CSN;
            Trace.Unindent();
            Trace.WriteLine("END Console Test Result Form");
        }

        private void ParseAndDisplayTestResults()
        {
            Trace.WriteLine("BEGIN ParseAndDisplayTestResults()");
            Trace.Indent();

            // **************************************************
            // **** CHECK GLOBAL VARIABLES FOR TEST RESULTS *****
            //***************************************************
            if (gv.WCM.Contains("PASS"))
            {
                Trace.WriteLine("WCM PASS");
                buttonPartNumber.BackColor = Color.Aquamarine; // PN - Part Number
                buttonWCM.BackColor = Color.Aquamarine; // WCM - PASS
            }
            else
            {
                if (gv.WCM.Contains("YELO") || gv.WCM.Contains("FAIL"))
                {
                    Trace.WriteLine("WCM FAIL");
                    buttonPartNumber.BackColor = Color.Orange; // PN - Part Number
                    buttonWCM.BackColor = Color.Orange; // WCM - FAIL
                    gv.WCM = "FAIL";
                    OperatorInstructions.Text += "Check Wireless Charge Module Connector\r\nThen click OK to retest unit\r\n";
                }
            }

            if (gv.SIB.Contains("PASS"))
            {
                Trace.WriteLine("SIB PASS");
                buttonPartNumber.BackColor = Color.Aquamarine; // PN - Part Number
                buttonSIB.BackColor = Color.Aquamarine; // SIB - PASS
            }
            else
            {
                Trace.WriteLine("SIB FAIL");
                if (gv.SIB.Contains("YELO") || gv.SIB.Contains("FAIL"))
                {
                    buttonPartNumber.BackColor = Color.Orange; // PN - Part Number
                    buttonSIB.BackColor = Color.Orange; // SIB - FAIL
                    gv.SIB = "FAIL";
                    OperatorInstructions.Text += "Check Shifter Interface Board Connector\r\nThen click OK to retest unit\r\n";
                }
                
            }

            if (gv.EOCM.Contains("PASS"))
            {
                Trace.WriteLine("EOCM PASS");
                buttonPartNumber.BackColor = Color.Aquamarine; // PN - Part Number
                buttonEOCM.BackColor = Color.Aquamarine; // EOCM - PASS
            }
            else
            {
                if (gv.EOCM.Contains("YELO") || gv.EOCM.Contains("FAIL"))
                {
                    Trace.WriteLine("EOCM PASS");
                    buttonPartNumber.BackColor = Color.Orange; // PN - Part Number
                    buttonEOCM.BackColor = Color.Orange; // SIB - FAIL
                    gv.EOCM = "FAIL";
                    OperatorInstructions.Text += "Check EOCM Connector\r\nThen click OK to retest unit\r\n";
                }
            }

            if (gv.SEAT.Contains("PASS"))
            {
                Trace.WriteLine("SEAT PASS");
                buttonSEAT.BackColor = Color.Aquamarine; // SEAT - PASS
            }
            else
            {
                if (gv.SEAT.Contains("YELO") || gv.SEAT.Contains("FAIL"))
                {
                    Trace.WriteLine("SEAT FAIL");
                    buttonSEAT.BackColor = Color.Orange; //
                    gv.SEAT = "FAIL";
                    OperatorInstructions.Text += "Check Heated Seat Switch Connector\r\nThen click OK to retest unit\r\n";
                }
            }

            if (gv.TBS.Contains("PASS"))
            {
                Trace.WriteLine("TBS PASS");
                buttonTBS.BackColor = Color.Aquamarine; // TBS - PASS
            }
            else
            {
                if (gv.TBS.Contains("YELO") || gv.TBS.Contains("FAIL"))
                {
                    Trace.WriteLine("TBS FAIL");
                    buttonTBS.BackColor = Color.Orange; // PN - Part Number
                    gv.TBS = "FAIL";
                    OperatorInstructions.Text += "Check Trailer Brake Switch Connector\r\nThen click OK to retest unit\r\n";
                }
            }

            if (gv.LAMP.Contains("PASS")) // LAMP TEST RESULTS
            {
                Trace.WriteLine("LAMP PASS");
                buttonLAMP.BackColor = Color.Aquamarine; //  PASS
            }
            else
            {
                if (gv.LAMP.Contains("YELO") || gv.LAMP.Contains("FAIL"))
                {
                    Trace.WriteLine("LAMP FAIL");
                    buttonLAMP.BackColor = Color.Orange; // FAIL
                    gv.LAMP = "FAIL";
                    OperatorInstructions.Text += "Check Main Console Lamp Connector\r\n";
                }
            }

            if (gv.PEPS.Contains("PASS")) // PEPS ANTENNA TEST RESULT
            {
                Trace.WriteLine("PEPS PASS");
                buttonPEPS.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.PEPS.Contains("YELO") || gv.PEPS.Contains("FAIL"))
                {
                    Trace.WriteLine("PEPS FAIL");
                    buttonPEPS.BackColor = Color.Orange; // FAIL
                    gv.PEPS = "FAIL";
                    OperatorInstructions.Text += "Check PEPS Antenna Connector\r\n";
                }
            }

            if (gv.IMOB.Contains("PASS")) // IMMOBILIZER ANTENNA TEST RESULT
            {
                Trace.WriteLine("IMOB PASS");
                buttonIMOB.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.IMOB.Contains("YELO") || gv.IMOB.Contains("FAIL"))
                {
                    Trace.WriteLine("IMOB FAIL");
                    buttonIMOB.BackColor = Color.Orange; // FAIL
                    gv.IMOB = "FAIL";
                    OperatorInstructions.Text += "Check Immobilizer Antenna Connector\r\n";
                }
            }

            if (gv.HVPO.Contains("PASS")) // HIGH VOLTAGE POWER OUTLET
            {
                Trace.WriteLine("HVPO PASS");
                button34.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.HVPO.Contains("YELO") || gv.HVPO.Contains("FAIL"))
                {
                    Trace.WriteLine("HVPO FAIL");
                    button34.BackColor = Color.Orange; // FAIL
                    gv.HVPO = "FAIL";
                    OperatorInstructions.Text += "Check High Voltage Power Outlet Connector\r\n";
                }
            }

            if (gv.ENDCAP_USB_TEST.Contains("PASS")) // ENDCAP USB TEST RESULT
            {
                Trace.WriteLine("ENDCAP PASS");
                buttonEndcapUSB.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.ENDCAP_USB_TEST.Contains("YELO") || gv.ENDCAP_USB_TEST.Contains("FAIL"))
                {
                    Trace.WriteLine("ENDCAP FAIL");
                    buttonEndcapUSB.BackColor = Color.Orange; // FAIL
                    gv.ENDCAP_USB_TEST = "FAIL";
                    OperatorInstructions.Text += "Check USB Endcap Connector\r\n";
                }
            }

            if (gv.ENDCAP_USB_SCAN.Contains("PASS")) // ENDCAP USB RFID BADGE SCAN RESULT
            {
                Trace.WriteLine("ENDCAP SCANNED");
                buttonEndcapResult.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.ENDCAP_USB_SCAN.Contains("YELO") || gv.ENDCAP_USB_SCAN.Contains("FAIL"))
                {
                    buttonEndcapResult.BackColor = Color.Orange; // FAIL
                    gv.ENDCAP_USB_SCAN = "FAIL";
                    OperatorInstructions.Text += "Check USB Endcap Connector\r\n";
                }
            }

            if (gv.BODY_USB_TEST.Contains("PASS")) // BODY USB TEST RESULT
            {
                Trace.WriteLine("BODY PASS");
                buttonBodyUSB.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.BODY_USB_TEST.Contains("YELO") || gv.BODY_USB_TEST.Contains("FAIL"))
                {
                    Trace.WriteLine("BODY FAIL");
                    buttonBodyUSB.BackColor = Color.Orange; // FAIL
                    gv.BODY_USB_TEST = "FAIL";
                    OperatorInstructions.Text += "Check USB Body Connector\r\n";
                }
            }

            if (gv.BODY_USB_SCAN.Contains("PASS")) // BODY USB TEST RESULT
            {
                Trace.WriteLine("BODY SCANNED");
                buttonBodyResult.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.BODY_USB_SCAN.Contains("YELO") || gv.BODY_USB_TEST.Contains("FAIL"))
                {
                    buttonBodyResult.BackColor = Color.Orange; // FAIL
                    gv.BODY_USB_SCAN = "FAIL";
                    OperatorInstructions.Text += "Check USB Body Scan\r\n";
                }
            }

            if (gv.CUPHOLDER_USB_TEST.Contains("PASS")) // CUPHOLDER USB TEST RESULT
            {
                Trace.WriteLine("CUPHOLDER PASS");
                buttonCupholderUSB.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.CUPHOLDER_USB_TEST.Contains("YELO") || gv.CUPHOLDER_USB_TEST.Contains("FAIL"))
                {
                    Trace.WriteLine("CUPHOLDER FAIL");
                    buttonCupholderUSB.BackColor = Color.Orange; // FAIL
                    gv.CUPHOLDER_USB_TEST = "FAIL";
                    OperatorInstructions.Text += "Check USB Cup holder Connector\r\n";
                }
            }

            if (gv.CUPHOLDER_USB_SCAN.Contains("PASS")) // CUPHOLDER USB RFID BADGE SCAN RESULT
            {
                Trace.WriteLine("CUPHOLDER SCANNED");
                buttonCupholder.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.CUPHOLDER_USB_SCAN.Contains("YELO") || gv.CUPHOLDER_USB_TEST.Contains("FAIL"))
                {
                    buttonCupholder.BackColor = Color.Orange; // FAIL
                    gv.CUPHOLDER_USB_TEST = "FAIL";
                    OperatorInstructions.Text += "Check USB Cup holder scan\r\n";
                }
            }
        }

        private void buttonHighlineManifest_Click(object sender, EventArgs e)
        {
            Trace.WriteLine("buttonHighlineManifest_Click()");
            gv.Manifest = "HIGHLINE MANUAL ENTRY";

            //   button31.BackColor = Color.Yellow;// PN

            // CONSOLE MANIFEST - Highline
            //Manifest_Options_old.Text = ""; // Clear Screen
            //Manifest_Options_old.Text = "0000000355149,103xxxxxxxxxx,0000004364960,13525890FT12,1502,13529874FW86,3002,13529875FW85,4301,135619101FT06,402,13592451FT45,1302,85117464FT09,1101,84638621GO2A,2701,13592452FW74,3501,84952174FW83,4201,84786104FW68,3101,84960563M33V,3301,13537143M08L,2901,";
            PrepareTestsPerManifest();

            timer1.Stop();
            //Form3 frm3 = new Form3();
            gv.ConsoleTestMainForm.Show();
        }

        private void buttonMidlineManifest_Click(object sender, EventArgs e)
        {
            Trace.WriteLine("buttonMidlineManifest_Click()");
            //  button31.BackColor = Color.Yellow;

            gv.Manifest = "MIDLINE MANUAL ENTRY";

            // CONSOLE MANIFEST - Midline
            //Manifest_Options_old.Text = ""; // Clear Screen
            //Manifest_Options_old.Text = "0000000355149,103xxxxxxxxxx,0000004364960,13525890FT12,1502,13529874FW86,3002,135619101FT06,402,13592451FT45,1302,85117464FT09,1101,84638621GO2A,2701,84952174FW83,4201,13537143M08L,2901,";
            PrepareTestsPerManifest();

            timer1.Stop();
            //Form3 frm3 = new Form3();
            gv.ConsoleTestMainForm.Show();
        }

        private void buttonBaseManifest_Click(object sender, EventArgs e)
        {
            Trace.WriteLine("buttonBaseManifest_Click()");
            buttonBaseManifest.BackColor = Color.Yellow; // BASE SELECTED SO TURN BUTTON COLOR YELLOW

            // button31.BackColor = Color.Yellow; // PN MODULE PART NUMBER IS TESTED FOR BASE

            gv.Manifest = "BASE MANUAL ENTRY";

            // CONSOLE MANIFEST - Base
            //Manifest_Options_old.Text = ""; // Clear Screen
            //Manifest_Options_old.Text = "0000000355149,103xxxxxxxxxx,0000004364960,13529874FW86,3002,84638621GO2A,2701,135619101FT06,402,";
            PrepareTestsPerManifest();

            timer1.Stop();
            //Form3 frm3 = new Form3();
            gv.ConsoleTestMainForm.Show();
        }

        private void PrepareTestsPerManifest()
        {
            Trace.WriteLine("BEGIN PrepareTestsPerManifest()");
            Trace.Indent();
            // ******************************************
            // ********* MOD codes for USB test *********
            // ******************************************

            if (gv.ConsoleTestMainForm.ManifestData.HeadModcode[4301] != "") // Search Manifest for Modcode (Cupholder USB)
            {
                Trace.WriteLine("Cupholder Present in Manifest Data as 4301");
                buttonCupholderUSB.BackColor = Color.Yellow;
                buttonCupholder.BackColor = Color.Yellow;
                gv.CUPHOLDER_USB_SCAN = "YELO";
                gv.CUPHOLDER_USB_TEST = "YELO";
                PLC.Results.TEST[gv.testCUPHOLDER].ModCode = "2901";
            }
            else
            {
                buttonCupholderUSB.BackColor = Color.LightGray;
                buttonCupholder.BackColor = Color.LightGray;
                gv.CUPHOLDER_USB_SCAN = "GRAY";
                gv.CUPHOLDER_USB_TEST = "GRAY";
            }

            if ((gv.ConsoleTestMainForm.ManifestData.HeadModcode[3002] != "") || (gv.ConsoleTestMainForm.ManifestData.HeadModcode[3001] != "")) // Search Manifest for Modcode (Body USB)
            {
                Trace.WriteLine("Body Present in Manifest Data as 3002");
                buttonBodyUSB.BackColor = Color.Yellow;
                buttonBodyResult.BackColor = Color.Yellow;
                gv.BODY_USB_SCAN = "YELO";
                gv.BODY_USB_TEST = "YELO";
                if (gv.ConsoleTestMainForm.ManifestData.HeadModcode[3002] != "")
                    PLC.Results.TEST[gv.testBODY].ModCode = "3002";
                else
                    PLC.Results.TEST[gv.testBODY].ModCode = "3001";
            }
            else
            {
                buttonBodyUSB.BackColor = Color.LightGray;
                buttonBodyResult.BackColor = Color.LightGray;
                gv.BODY_USB_SCAN = "GRAY";
                gv.BODY_USB_TEST = "GRAY";
            }

            if (gv.ConsoleTestMainForm.ManifestData.HeadModcode[1502] != "") // Search Manifest for Modcode (Endcap USB)
            {
                Trace.WriteLine("Endcap Present in Manifest Data as 1502");
                buttonEndcapUSB.BackColor = Color.Yellow;
                buttonEndcapResult.BackColor = Color.Yellow;
                gv.ENDCAP_USB_SCAN = "YELO";
                gv.ENDCAP_USB_TEST = "YELO";
                PLC.Results.TEST[gv.testENDCAP].ModCode = "1502";
            }
            else
            {
                buttonEndcapUSB.BackColor = Color.LightGray;
                buttonEndcapResult.BackColor = Color.LightGray;
                gv.ENDCAP_USB_SCAN = "GRAY";
                gv.ENDCAP_USB_TEST = "GRAY";
            }

            // ******************************************
            // ********* All Other MOD codes ************
            // ******************************************

            if (gv.ConsoleTestMainForm.ManifestData.HeadModcode[3301] != "") // Search Manifest for Modcode (EOCM)
            {
                Trace.WriteLine("EOCM Present in Manifest Data as 3301");
                buttonEOCM.BackColor = Color.Yellow;
                gv.EOCM = "YELO";
                PLC.Results.EOCMModuleModCode = "3301";
            }
            else
            {
                buttonEOCM.BackColor = Color.LightGray;
                gv.EOCM = "GRAY";
            }

            if (gv.ConsoleTestMainForm.ManifestData.HeadModcode[2901] != "") // Search Manifest for Modcode (WCM - WIRELESS CHARGE MODULE)
            {
                Trace.WriteLine("WCM Present in Manifest Data as 2901");
                buttonWCM.BackColor = Color.Yellow;
                gv.WCM = "YELO";
                PLC.Results.WCMModuleModCode = "2901";
            }
            else
            {
                buttonWCM.BackColor = Color.LightGray;
                gv.WCM = "GRAY";
            }

            if (gv.ConsoleTestMainForm.ManifestData.HeadModcode[1101] != "")  // Search Manifest for Modcode (HEATED SEAT SW.)
            {
                Trace.WriteLine("SEAT Present in Manifest Data as 1101");
                buttonSEAT.BackColor = Color.Yellow;
                gv.SEAT = "YELO";
                PLC.Results.TEST[gv.testSEAT].ModCode = "1101";
            }
            else
            {
                buttonSEAT.BackColor = Color.LightGray;
                gv.SEAT = "GRAY";
            }

            if ((gv.ConsoleTestMainForm.ManifestData.HeadModcode[1302] != "") && (gv.ConsoleTestMainForm.ManifestData.HeadModcode[1301] != "")) // Search Manifest for Modcode (PEPS ANTENNA)
            {
                buttonPEPS.BackColor = Color.Yellow;
                gv.PEPS = "YELO";
                if (gv.ConsoleTestMainForm.ManifestData.HeadModcode[1302] != "")
                {
                    Trace.WriteLine("PEPS Present in Manifest Data as 1302");
                    PLC.Results.TEST[gv.testPEPS].ModCode = "1302";
                }
                else
                {
                    Trace.WriteLine("PEPS Present in Manifest Data as 1301");
                    PLC.Results.TEST[gv.testPEPS].ModCode = "1301"; 
                }
            }
            else
            {
                buttonPEPS.BackColor = Color.LightGray;
                gv.PEPS = "GRAY";
            }

            if (gv.ConsoleTestMainForm.ManifestData.HeadModcode[2701] != "") // Search Manifest for Modcode (SIB - SHIFT INTERFACE BOARD)
            {
                Trace.WriteLine("PEPS Present in Manifest Data as 2701");
                buttonSIB.BackColor = Color.Yellow;
                gv.SIB = "YELO";
                PLC.Results.SIBModuleModCode = "2701";

            }
            else
            {
                buttonSIB.BackColor = Color.LightGray;
                gv.SIB = "GRAY";
            }

            if (gv.ConsoleTestMainForm.ManifestData.HeadModcode[4201] != "") // Search Manifest for Modcode (TRAILER BRAKE SWITCH)
            {
                Trace.WriteLine("TBS Present in Manifest Data as 4201");
                buttonTBS.BackColor = Color.Yellow;
                gv.TBS = "YELO";
                PLC.Results.TEST[gv.testTBS].ModCode = "4201";
            }
            else
            {
                buttonTBS.BackColor = Color.LightGray;
                gv.TBS = "GRAY";
            }

            if (gv.ConsoleTestMainForm.ManifestData.HeadModcode[402] != "")  // Search Manifest for Modcode (MAIN CONSOLE LAMP)
            {
                Trace.WriteLine("LAMP Present in Manifest Data as 402");
                buttonLAMP.BackColor = Color.Yellow;
                gv.LAMP = "YELO";
                PLC.Results.TEST[gv.testLAMP].ModCode = "402";
            }
            else
            {
                buttonLAMP.BackColor = Color.LightGray;
                gv.LAMP = "GRAY";
            }

            if (gv.ConsoleTestMainForm.ManifestData.HeadModcode[3501] != "")  // Search Manifest for Modcode (IMMOBILIZER ANTENNA)
            {
                Trace.WriteLine("IMOB Present in Manifest Data as 3501");
                buttonIMOB.BackColor = Color.Yellow;
                gv.IMOB = "YELO";
                PLC.Results.TEST[gv.testIMOB].ModCode = "3501";
            }
            else
            {
                buttonIMOB.BackColor = Color.LightGray;
                gv.IMOB = "GRAY";
            }

            if ((gv.ConsoleTestMainForm.ManifestData.HeadModcode[3101] != "") && (gv.ConsoleTestMainForm.ManifestData.HeadModcode[3102] != "")) // Search Manifest for Modcode (HIGH VOLTAGE PO 3101)
            {
                button34.BackColor = Color.Yellow;
                gv.HVPO = "YELO";
                if (gv.ConsoleTestMainForm.ManifestData.HeadModcode[3101] != "")
                {
                    Trace.WriteLine("HVPO Present in Manifest Data as 3101");
                    PLC.Results.TEST[gv.testHVPO].ModCode = "3101";
                }
                else
                {
                    PLC.Results.TEST[gv.testHVPO].ModCode = "3102";
                }

            }
            else
            {
                button34.BackColor = Color.LightGray;
                gv.HVPO = "GRAY";
            }
        }

        /* The Console test Results form just hangs around checking the digital inputs to see if the 55Way is connected
         * if the 55Way is connected it constantly re-tests the Cupholder, Body, and Endcap via the USB testing
        */
        private void timer1_Tick(object sender, EventArgs e)
        {
            PLC.Heartbeat();

            if (gv.LAMP == "FAIL") gv.LAMP = "YELO";
            if (gv.IMOB == "FAIL") gv.IMOB = "YELO";
            if (gv.HVPO == "FAIL") gv.HVPO = "YELO";
            if (gv.PEPS == "FAIL") gv.PEPS = "YELO";

            if ( PLC.bGetStart() ||  cbFakePLCStart.Checked)
            {
                buttonTestStart_Click(null, EventArgs.Empty);
            }

            ConsoleTestForm3.ReadDigitalInputs(out bool bConsole_PIP_55Way_Detected, out bool b5VUSBDetected);
            gv.ConsoleTestMainForm.HandleManualRelease(bConsole_PIP_55Way_Detected);
            if (bConsole_PIP_55Way_Detected) // Console_PIP_55Way has been detected
            {
                gv.DiagnosticForm.AcquireAndEvaluateAnalogInputs();
                ParseAndDisplayTestResults();

                buttonAcceptFailures.Visible = !bAllTestsPassed();

                if (OperatorInstructions.Text.Contains("Cycle Complete"))
                {
                    //HeadlinerConnectTestForm.Eject55Way();
                    HeadlinerTestForm.Eject59Way();
                }
                else
                {
                    if (bConsole_PIP_55Way_Detected) // Console_PIP_55Way has been detected
                    {
                        gv.ConsoleTestMainForm.TestUSB_Cupholder(b5VUSBDetected);
                        gv.ConsoleTestMainForm.TestUSB_Body(b5VUSBDetected);
                        gv.ConsoleTestMainForm.TestUSB_Endcap(b5VUSBDetected);
                        if (bAllTestsPassed())
                        {
                            OperatorInstructions.Text = "Cycle Complete - PASS\r\n" ;
                            PLC.SendTestPassed();
                            // write results to PLC, report results, blow off the connectors
                            PLC.UpdateResultsToPLC();
                        }
                    }
                }
            }
        }

        private bool bAllTestsPassed()
        {
            // if everything passed then return true
            return ((gv.CUPHOLDER_USB_TEST != "FAIL")
                && (gv.BODY_USB_TEST != "FAIL")
                && (gv.ENDCAP_USB_TEST != "FAIL")
                && (gv.LAMP != "FAIL")
                && (gv.IMOB != "FAIL")
                && (gv.HVPO != "FAIL")
                && (gv.PEPS != "FAIL")
                && (gv.WCM != "FAIL")
                && (gv.EOCM != "FAIL")
                && (gv.SIB != "FAIL")
                && (gv.SEAT != "FAIL")
                && (gv.TBS != "FAIL")
                || false /* replace false with "Operator is trying to abort further retesting and accept the part under test as a failure" flag */
               );
        }

        private void buttonTestStart_Click(object sender, EventArgs e) // OK BUTTON
        {
            Trace.WriteLine("buttonTestStart_Click()");
            if (gv.ConsoleTestMainForm != null)
            {
                if (gv.RETEST == "Manual CSN Entry")
                {
                    gv.ConsoleTestMainForm.TopMost = true;
                    gv.ConsoleTestMainForm.InitDisplayBasedOnManifest();
                    gv.ConsoleTestMainForm.Show();
                    gv.ConsoleTestMainForm.TopMost = false;
                }
                else
                {
                    gv.RETEST = "false";
                    gv.ConsoleTestMainForm.Close();
                }
            }

        }

        private void buttonClear_Click(object sender, EventArgs e) // Clear Options Button Pressed
        {
            Trace.WriteLine("buttonClear_Click()");
            gv.Manifest = "MANUAL ENTRY";

            buttonSEAT.BackColor = Color.LightGray;
            buttonPEPS.BackColor = Color.LightGray;
            buttonSIB.BackColor = Color.LightGray;
            buttonTBS.BackColor = Color.LightGray;
            buttonLAMP.BackColor = Color.LightGray;
            buttonIMOB.BackColor = Color.LightGray;
            buttonWCM.BackColor = Color.LightGray;
            buttonEOCM.BackColor = Color.LightGray;
            buttonBodyUSB.BackColor = Color.LightGray;
            buttonEndcapUSB.BackColor = Color.LightGray;
            buttonBodyResult.BackColor = Color.LightGray;
            buttonEndcapResult.BackColor = Color.LightGray;
            buttonPartNumber.BackColor = Color.LightGray;
            buttonCupholderUSB.BackColor = Color.LightGray;
            buttonCupholder.BackColor = Color.LightGray;
            button34.BackColor = Color.LightGray;
        }

        private void buttonAcceptFailures_Click(object sender, EventArgs e) // CANCEL BUTTON PRESSED Blow-off 55-way
        {
            Trace.WriteLine("buttonAcceptFailures_Click()");
            // send results to PLC, report failures,
            timer1.Stop();
            OperatorInstructions.Text = "Cycle Complete, with failures\r\n\r\n";
            PLC.SendTestFailed();
            HeadlinerTestForm.Eject55Way();
        }

        private void button32_Click(object sender, EventArgs e)  // FOR DEMO ONLY! START ANALOG TEST
        {
            Trace.WriteLine("button32_Click()");
            timer1.Stop();
            //Form1 frm1 = new Form1();
            gv.DiagnosticForm.Show();
        }

        private void button33_Click(object sender, EventArgs e) // FOR DEMO SEND TEST RESULTS TO PLC
        {
            Trace.WriteLine("button33_Click()");
            OperatorInstructions.Text = "";
            OperatorInstructions.Text += "REPORT TEST RESULTS TO PLC";

            //global_variables.WCM = "PASS";
            //global_variables.WCM_BASE_PN = textBoxWCM_BaseModelPartNumber8.Text;
            //global_variables.WCM_END_PN = textBoxWCM_EndModelPartNumber8.Text;
            //global_variables.WCM_BOOT_PN = textBoxWCM_BootSWID8.Text;
            //global_variables.WCM_ASWID_PN = textBoxWCM_AppSWID10.Text;
            // global_variables.WCM_ADATAID_PN = textBoxWCM_AppDataID10.Text;
            //global_variables.PN_TIME_READ = TextBox_Time_of_PN_Read.Text;
            //global_variables.PN_DATE_READ = TextBox_Date_of_PN_Read.Text;

            // global_variables.SIB = "PASS";
            // global_variables.SIB_BASE_PN = textBoxSIB_BaseModelPartNumber8.Text;
            // global_variables.SIB_END_PN = textBoxSIB_EndModelPartNumber8.Text;
            //  global_variables.SIB_BOOT_PN = textBoxSIB_BootSWID8.Text;
            //  global_variables.SIB_ASWID_PN = textBoxSIB_AppSWID10.Text;
            //  global_variables.SIB_ADATAID_PN = textBoxSIB_AppDataID10.Text;
            //   global_variables.PN_TIME_READ = TextBox_Time_of_PN_Read.Text;
            //   global_variables.PN_DATE_READ = TextBox_Date_of_PN_Read.Text;

            //   global_variables.EOCM = "PASS";
            //  global_variables.EOCM_BASE_PN = textBoxEOCM_BaseModelPartNumber8.Text;
            //  global_variables.EOCM_END_PN = textBoxEOCM_EndModelPartNumber8.Text;
            //  global_variables.EOCM_BOOT_PN = textBoxEOCM_BootSWID8.Text;
            //   global_variables.EOCM_ASWID_PN = textBoxEOCM_AppSWID10.Text;
            //   global_variables.EOCM_ADATAID_PN = textBoxEOCM_AppDataID10.Text;
            //   global_variables.PN_TIME_READ = TextBox_Time_of_PN_Read.Text;
            //   global_variables.PN_DATE_READ = TextBox_Date_of_PN_Read.Text;

            //   global_variables.LIN_SEAT_SW = "PASS";

            //   global_variables.LIN_TBS = "PASS";
        }

        private void button7_Click(object sender, EventArgs e) // PN DEFAULT IS YELLOW
        {
            Trace.WriteLine("button7_Click()");
        }

        private void button34_Click(object sender, EventArgs e) // HVPO
        {
            Trace.WriteLine("button34_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.HVPO == "YELO" )
            {
                button34.BackColor = Color.LightGray;
                gv.HVPO = "GRAY";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[3101] = "";
            }
            else
            {
                button34.BackColor = Color.Yellow;
                gv.HVPO = "YELO";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[3101] = "asdfsdf";
            }
        }

        private void button13_Click(object sender, EventArgs e) // SEAT
        {
            Trace.WriteLine("button13_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.SEAT == "YELO" )
            {
                buttonSEAT.BackColor = Color.LightGray;
                gv.SEAT = "GRAY";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[1101] = "";
                
            }
            else
            {
                buttonSEAT.BackColor = Color.Yellow;
                gv.SEAT = "YELO";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[1101] = "manual";
                
            }
        }

        private void button18_Click(object sender, EventArgs e) // PEPS
        {
            Trace.WriteLine("button18_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.PEPS == "YELO" )
            {
                buttonPEPS.BackColor = Color.LightGray;
                gv.PEPS = "GRAY";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[1302] = "";
            }
            else
            {
                buttonPEPS.BackColor = Color.Yellow;
                gv.PEPS = "YELO";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[1302] = "manual";
            }
        }

        private void button28_Click(object sender, EventArgs e) // SIB
        {
            Trace.WriteLine("button28_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.SIB == "YELO" )
            {
                buttonSIB.BackColor = Color.LightGray;
                gv.SIB = "GRAY";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[2701] = "";
            }
            else
            {
                buttonSIB.BackColor = Color.Yellow;
                gv.SIB = "YELO";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[2701] = "manual";
            }
        }

        private void button20_Click(object sender, EventArgs e) // TBS
        {
            Trace.WriteLine("button20_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.TBS == "YELO" )
            {
                buttonTBS.BackColor = Color.LightGray;
                gv.TBS = "GRAY";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[4201] = "";
            }
            else
            {
                buttonTBS.BackColor = Color.Yellow;
                gv.TBS = "YELO";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[4201] = "manual";
            }
        }

        private void button27_Click(object sender, EventArgs e) // LAMP
        {
            Trace.WriteLine("button27_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.LAMP == "YELO" )
            {
                buttonLAMP.BackColor = Color.LightGray;
                gv.LAMP = "GRAY";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[402] = "";
            }
            else
            {
                buttonLAMP.BackColor = Color.Yellow;
                gv.LAMP = "YELO";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[402] = "manual";
            }
        }

        private void button22_Click(object sender, EventArgs e) // IMOB
        {
            Trace.WriteLine("button22_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.IMOB == "YELO" )
            {
                buttonIMOB.BackColor = Color.LightGray;
                gv.IMOB = "GRAY";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[3501] = "";
            }
            else
            {
                buttonIMOB.BackColor = Color.Yellow;
                gv.IMOB = "YELO";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[3501] = "manual";
            }
        }

        private void button30_Click(object sender, EventArgs e) // WCM
        {
            Trace.WriteLine("button30_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.WCM == "YELO" )
            {
                buttonWCM.BackColor = Color.LightGray;
                gv.WCM = "GRAY";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[2901] = "";
            }
            else
            {
                buttonWCM.BackColor = Color.Yellow;
                gv.WCM = "YELO";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[2901] = "manual";
            }
        }

        private void button24_Click(object sender, EventArgs e) // EOCM
        {
            Trace.WriteLine("button24_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.EOCM == "YELO" )
            {
                buttonEOCM.BackColor = Color.LightGray;
                gv.EOCM = "GRAY";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[3301] = "";
            }
            else
            {
                buttonEOCM.BackColor = Color.Yellow;
                gv.EOCM = "YELO";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[3301] = "manual";
            }
        }

        private void buttonBodyUSB_Click(object sender, EventArgs e)  // BODY USB
        {
            Trace.WriteLine("buttonBodyUSB_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.BODY_USB_SCAN == "YELO" )
            {
                buttonBodyUSB.BackColor = Color.LightGray;
                buttonBodyResult.BackColor = Color.LightGray;
                gv.BODY_USB_SCAN = "GRAY";
                gv.BODY_USB_TEST = "GRAY";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[3002] = "";
            }
            else
            {
                buttonBodyUSB.BackColor = Color.Yellow;
                buttonBodyResult.BackColor = Color.Yellow;
                gv.BODY_USB_SCAN = "YELO";
                gv.BODY_USB_TEST = "YELO";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[3002] = "manual";
            }
        }
        private void buttonCupholderUSB_Click(object sender, EventArgs e)
        {
            Trace.WriteLine("buttonCupholderUSB_Click()");
            gv.Manifest = "MANUAL ENTRY"; // CUPHOLDER USB TEST

            if ( gv.CUPHOLDER_USB_SCAN == "YELO" )
            {
                buttonCupholderUSB.BackColor = Color.LightGray;
                buttonCupholder.BackColor = Color.LightGray;
                gv.CUPHOLDER_USB_SCAN = "GRAY";
                gv.CUPHOLDER_USB_TEST = "GRAY";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[4301] = "";
            }
            else
            {
                buttonCupholderUSB.BackColor = Color.Yellow;
                buttonCupholder.BackColor = Color.Yellow;
                gv.CUPHOLDER_USB_SCAN = "YELO";
                gv.CUPHOLDER_USB_TEST = "YELO";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[4301] = "manual";
            }
        }

        private void buttonEndcapUSB_Click(object sender, EventArgs e) // ENDCAP USB
        {
            Trace.WriteLine("buttonEndcapUSB_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.ENDCAP_USB_SCAN == "YELO" )
            {
                buttonEndcapUSB.BackColor = Color.LightGray;
                buttonEndcapResult.BackColor = Color.LightGray;
                gv.ENDCAP_USB_SCAN = "GRAY";
                gv.ENDCAP_USB_TEST = "GRAY";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[1502] = "";
            }
            else
            {
                buttonEndcapUSB.BackColor = Color.Yellow;
                buttonEndcapResult.BackColor = Color.Yellow;
                gv.ENDCAP_USB_SCAN = "YELO";
                gv.ENDCAP_USB_TEST = "YELO";
                gv.ConsoleTestMainForm.ManifestData.HeadModcode[1502] = "manual";
            }
        }

        private void cbFakePLCStart_CheckedChanged(object sender, EventArgs e)
        {
            
        }
    }
}