﻿using AIOUSBNet;  // namespace exposes AIOUSB Class interface
using System;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;

namespace Sample1
{
    public partial class HeadlinerTestResultsOptionsForm : Form
    {
        public HeadlinerTestResultsOptionsForm()
        {
            InitializeComponent();
        }

        private void buttonBCMLIN5_Click(object sender, EventArgs e)
        {
            Trace.WriteLine("buttonBCMLIN5_Click()");
            if ( gv.BCM.Contains("YELO") )
            {
                buttonBCMLIN5.BackColor = Color.LightGray;
            }
            else
            {
                buttonBCMLIN5.BackColor = Color.Yellow;
            }
        }

        private void HeadlinerTestResultsOptionsForm_Load(object sender, EventArgs e)
        {
            Trace.WriteLine("BEGIN HeadlinerTestResultsOptionsForm_Load()");
            Trace.Indent();
            // Display Software Version
            labelSoftware_Version.Text = gv.SOFTWARE_VERSION;

            // CONSOLE MANIFEST - Highline (default)
            Manifest_Options.Text = ""; // Clear Screen
            Manifest_Options.Text = "0000000355149,103xxxxxxxxxx,0000004364960,84874628FT28,501,84810967M38A,200,84793091FT29,301,84660808A28B,901,????????????,601,????????????,602,????????????,603,????????????,604,85116495M40P,601,846608188A28A,801,84798058FW80,1801,";

            // PARSE OUT THE CSN #
            PLC.Results.CSN = Manifest_Options.Text.Substring(28, 13);
            textBoxfrm5VIN.Text = PLC.Results.CSN;
            EvaluateGlobalResults();

            Trace.WriteLine("Starting Timer");
            timer1.Start();
            Trace.Unindent();
            Trace.WriteLine("END HeadlinerTestResultsOptionsForm_Load()");
        }

        private void EvaluateGlobalResults()
        {
            Trace.WriteLine("BEGIN EvaluateGlobalResults()");
            Trace.Indent();

            OperatorInstructions.Text = "";
            // **************************************************
            // **** CHECK GLOBAL VARIABLES FOR TEST RESULTS *****
            //***************************************************
            /*            //if (global_variables.ANCMIC.Contains("PASS")) button5.BackColor = Color.Aquamarine;
                        if (gv.ANCMIC.Contains("FAIL")) button5.BackColor = Color.Orange;
                        //if (global_variables.CMIC.Contains("PASS")) button13.BackColor = Color.Aquamarine;
                        if (gv.CMIC.Contains("FAIL")) button13.BackColor = Color.Orange;
            */
            if ( gv.CMIC.Contains("PASS") )
            {
                Trace.WriteLine("CMIC PASS");
                button13.BackColor = Color.Aquamarine; // CMIC - PASS
            }
            else
            {
                if ( gv.CMIC.Contains("YELO") || gv.CMIC.Contains("FAIL") )
                {
                    Trace.WriteLine("CMIC FAIL");
                    button13.BackColor = Color.Orange; // CMIC - FAIL
                    gv.CMIC = "FAIL";
                    OperatorInstructions.Text += "Check Left Mic connection -- \r\n";
                }
            }

            if ( gv.MIC.Contains("PASS") )
            {
                Trace.WriteLine("MIC PASS");
                button28.BackColor = Color.Aquamarine; // MIC - PASS
            }
            else
            {
                if ( gv.MIC.Contains("YELO") || gv.MIC.Contains("FAIL") )
                {
                    Trace.WriteLine("MIC FAIL");
                    button28.BackColor = Color.Orange; // MIC - FAIL
                    gv.MIC = "FAIL";
                    OperatorInstructions.Text += "Check Right Mic connection -- \r\n";
                }
            }

            if ( gv.ANCMIC.Contains("PASS") )
            {
                Trace.WriteLine("ANCMIC PASS");
                button5.BackColor = Color.Aquamarine; // ANCMIC - PASS
            }
            else
            {
                if ( gv.ANCMIC.Contains("YELO") || gv.ANCMIC.Contains("FAIL") )
                {
                    Trace.WriteLine("ANCMIC FAIL");
                    button5.BackColor = Color.Orange; // ANCMIC - FAIL
                    gv.ANCMIC = "FAIL";
                    OperatorInstructions.Text += "Check Noise-Cancellation Mic connection -- \r\n";
                }
            }

            if ( gv.LAMP_H.Contains("PASS") )
            {
                Trace.WriteLine("LAMP PASS");
                button27.BackColor = Color.Aquamarine; // LAMP_H - PASS
            }
            else
            {
                if ( gv.LAMP_H.Contains("YELO") || gv.LAMP_H.Contains("FAIL") )
                {
                    Trace.WriteLine("LAMP FAIL");
                    button27.BackColor = Color.Orange; // LAMP_H - FAIL
                    gv.LAMP_H = "FAIL";
                    OperatorInstructions.Text += "Check Dome Lamp connection -- \r\n";
                }
            }

            if ( gv.ECLAMP.Contains("PASS") )
            {
                Trace.WriteLine("ECLAMP PASS");
                button30.BackColor = Color.Aquamarine; // ECLAMP - PASS
            }
            else
            {
                if ( gv.ECLAMP.Contains("YELO") || gv.ECLAMP.Contains("FAIL") )
                {
                    Trace.WriteLine("ECLAMP FAIL");
                    button30.BackColor = Color.Orange; // ECLAMP - FAIL
                    gv.ECLAMP = "FAIL";
                    OperatorInstructions.Text += "Check ECLAMP connection -- \r\n";
                }
            }

            if ( gv.BCM.Contains("PASS") )
            {
                Trace.WriteLine("BCM PASS");
                buttonBCMLIN5.BackColor = Color.Aquamarine; // BCM - PASS
            }
            else
            {
                Trace.WriteLine("BMC FAIL");
                if ( gv.BCM.Contains("YELO") || gv.BCM.Contains("FAIL") )
                {
                    buttonBCMLIN5.BackColor = Color.Orange; // BCM - FAIL
                    gv.BCM = "FAIL";
                    OperatorInstructions.Text += "Check BCM connection -- \r\n";
                }
            }

            if ( gv.MIRROR.Contains("PASS") )
            {
                Trace.WriteLine("MIRROR PASS");
                button20.BackColor = Color.Aquamarine; // MIRROR - PASS
            }
            else
            {
                if ( gv.MIRROR.Contains("YELO") || gv.MIRROR.Contains("FAIL") )
                {
                    Trace.WriteLine("MIRROR FAIL");
                    button20.BackColor = Color.Orange; // MIRROR - FAIL
                    gv.MIRROR = "FAIL";
                    OperatorInstructions.Text += "Check Mirror connection -- \r\n";
                }
            }

            if ( gv.R2LAMPS.Contains("PASS") )
            {
                Trace.WriteLine("R2LAMPS PASS");
                button22.BackColor = Color.Aquamarine; // R2LAMPS - PASS
            }
            else
            {
                if ( gv.R2LAMPS.Contains("YELO") || gv.R2LAMPS.Contains("FAIL") )
                {
                    Trace.WriteLine("R2LAMPS FAIL");
                    button22.BackColor = Color.Orange; // R2LAMPS - FAIL
                    gv.R2LAMPS = "FAIL";
                    OperatorInstructions.Text += "Check R2LAMPS connection -- \r\n";
                }
            }

            if ( gv.R2LAMPS2_H.Contains("PASS") )
            {
                Trace.WriteLine("R2LAMPS2_H PASS");
                button24.BackColor = Color.Aquamarine; // R2LAMPS2_H - PASS
            }
            else
            {
                if ( gv.R2LAMPS2_H.Contains("YELO") || gv.R2LAMPS2_H.Contains("FAIL") )
                {
                    Trace.WriteLine("R2LAMPS2_H FAIL");
                    button24.BackColor = Color.Orange; // R2LAMPS2_H - FAIL
                    gv.R2LAMPS2_H = "FAIL";
                    OperatorInstructions.Text += "Check RSLAMPS2_H connection -- \r\n";
                }
            }

            if ( gv.LSLAMP.Contains("PASS") )
            {
                Trace.WriteLine("LSLAMP PASS");
                button7.BackColor = Color.Aquamarine; // LSLAMP - PASS
            }
            else
            {
                if ( gv.LSLAMP.Contains("YELO") || gv.LSLAMP.Contains("FAIL") )
                {
                    Trace.WriteLine("LSLAMP FAIL");
                    button7.BackColor = Color.Orange; // LSLAMP - FAIL
                    gv.LSLAMP = "FAIL";
                    OperatorInstructions.Text += "Check Left Sunvisor Lamp connection\r\n";
                }
            }

            if ( gv.RSLAMP.Contains("PASS") )
            {
                Trace.WriteLine("RSLAMP PASS");
                button43.BackColor = Color.Aquamarine; // RSLAMP - PASS
            }
            else
            {
                if ( gv.RSLAMP.Contains("YELO") || gv.RSLAMP.Contains("FAIL") )
                {
                    Trace.WriteLine("RSLAMP FAIL");
                    button43.BackColor = Color.Orange; // RSLAMP - FAIL
                    gv.RSLAMP = "FAIL";
                    OperatorInstructions.Text += "Check Right Sunvisor Lamp connection\r\n";
                }
            }

            if ( gv.R2LAMPC.Contains("PASS") )
            {
                Trace.WriteLine("R2LAMPC PASS");
                button31.BackColor = Color.Aquamarine; // R2LAMPC - PASS
            }
            else
            {
                if ( gv.R2LAMPC.Contains("YELO") || gv.R2LAMPC.Contains("FAIL") )
                {
                    Trace.WriteLine("R2LAMPC FAIL");
                    button31.BackColor = Color.Orange; // R2LAMPC - FAIL
                    gv.R2LAMPC = "FAIL";
                    OperatorInstructions.Text += "Check R2LAMPC connection -- \r\n";
                }
            }

            if ( gv.R2LAMPS2.Contains("PASS") )
            {
                Trace.WriteLine("R2LAMPS2 PASS");
                button33.BackColor = Color.Aquamarine; // R2LAMPS2 - PASS
            }
            else
            {
                if ( gv.R2LAMPS2.Contains("YELO") || gv.R2LAMPS2.Contains("FAIL") )
                {
                    Trace.WriteLine("R2LAMPS2 FAIL");
                    button33.BackColor = Color.Orange; // R2LAMPS2 - FAIL
                    gv.R2LAMPS2 = "FAIL";
                    OperatorInstructions.Text += "Check R2LAMPS2 connection -- \r\n";
                }
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            PLC.Heartbeat();
            if ( PLC.bGetStart() ||  cbFakePLCStart.Checked)
            {
                PLC.SendTesterReady();
                buttonStartTest_Click(null, EventArgs.Empty);
            }

            byte digin = ConsoleTestForm3.ReadDigitalInputs(out bool Headliner1, out bool b5VUSBDetected);
            bool Headliner2 = ((digin & 0x04) == 0x04); // Headliner 55-way
            bool Headliner3 = ((digin & 0x08) == 0x08); // Headliner 16-way X1 PIP Switch
            bool Headliner4 = ((digin & 0x10) == 0x10); // Headliner 16-way X2 PIP Switch
            if (gv.J2HDebugMode)
            {
                Headliner1 = gv.DiagnosticOverrideForm.DI1Detected;
                Headliner2 = gv.DiagnosticOverrideForm.DI2Detected;
                Headliner3 = gv.DiagnosticOverrideForm.DI3Detected;
                Headliner4 = gv.DiagnosticOverrideForm.DI4Detected;
            }
            
            //******************************************************************
            //*************  Check for operator to connect the harness
            //*******************************************************************

            if (((Headliner1) || (Headliner2)) && (Headliner3) && (Headliner4))
            {
                if (gv.CMIC == "FAIL") gv.CMIC = "YELO";
                if (gv.MIC == "FAIL") gv.MIC = "YELO";
                if (gv.RSLAMP == "FAIL") gv.RSLAMP = "YELO";
                if (gv.LSLAMP == "FAIL") gv.LSLAMP = "YELO";
                if (gv.ANCMIC == "FAIL") gv.ANCMIC = "YELO";
                if (gv.R2LAMPC == "FAIL") gv.R2LAMPC = "YELO";


                if (OperatorInstructions.Text.Contains("Cycle Complete"))
                {
                    // DO NOTHING
                    //textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "55-Way PIP detected\r\n" + "\r\n" + "\r\n";

                    // **************************************************************************************************************************
                    // ****************** Start the Console Test CYCLE COMPLETE Sequence *************************************************************
                    // **************************************************************************************************************************
                    //***************************************************************************************************************************
                    //***************************************************************************************************************************
                    HeadlinerTestForm.Eject59Way();
                    HeadlinerTestForm.Eject55Way();
                    HeadlinerTestForm.Eject16WayX1AndX2();
                    ConsoleTestForm3.TurnOffUSB5VLED();

                    /* if PLC says "Start Next Cycle" (rising edge on cycle start bit) then close this form */
                }
                else
                {
                    /* don't set cycle complete until everything is passing or the operator hits abort to accept a failed part */
                    if ((gv.CMIC != "YELO")
                        && (gv.MIC != "YELO")
                        && (gv.RSLAMP != "YELO")
                        && (gv.LSLAMP != "YELO")
                        && (gv.ANCMIC != "YELO")
                        && (gv.R2LAMPC != "YELO")
                        || (false /*replace false with operator abort flag */ )
                        )
                    {
                        //EvaluateGlobalResults();
                        PLC.SendTestPassed();
                        PLC.UpdateResultsToPLC();
                        OperatorInstructions.Text = OperatorInstructions.Text + "Cycle Complete\r\n" + "\r\n" + "\r\n";
                    }
                    else // if anything is not pass/skip
                    {
                        gv.DiagnosticForm.AcquireAndEvaluateAnalogInputs();
                        EvaluateGlobalResults();
                    }

                }
            }
        }

        private void buttonStartTest_Click(object sender, EventArgs e)
        {
            Trace.WriteLine("buttonStartTest_Click()");
            timer1.Stop();
            if (gv.HeadlinerConnectTestForm != null)
            {
                gv.HeadlinerConnectTestForm.Close();
            }
        }

        private void button13_Click(object sender, EventArgs e)// CMIC
        {
            Trace.WriteLine("button13_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.CMIC == "YELO" )
            {
                button13.BackColor = Color.LightGray;
                gv.CMIC = "GRAY";
            }
            else
            {
                button13.BackColor = Color.Yellow;
                gv.CMIC = "YELO";
            }
        }

        private void button28_Click(object sender, EventArgs e)// MIC
        {
            Trace.WriteLine("button28_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.MIC == "YELO" )
            {
                button28.BackColor = Color.LightGray;
                gv.MIC = "GRAY";
            }
            else
            {
                button28.BackColor = Color.Yellow;
                gv.MIC = "YELO";
            }
        }

        private void button5_Click(object sender, EventArgs e)//ANCMIC
        {
            Trace.WriteLine("button5_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.ANCMIC == "YELO" )
            {
                button5.BackColor = Color.LightGray;
                gv.ANCMIC = "GRAY";
            }
            else
            {
                button5.BackColor = Color.Yellow;
                gv.ANCMIC = "YELO";
            }
        }

        private void button27_Click(object sender, EventArgs e)// LAMP_H
        {
            Trace.WriteLine("button27_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.LAMP_H == "YELO" )
            {
                button27.BackColor = Color.LightGray;
                gv.LAMP_H = "GRAY";
            }
            else
            {
                button27.BackColor = Color.Yellow;
                gv.LAMP_H = "YELO";
            }
        }

        private void button30_Click(object sender, EventArgs e)// ECLAMP
        {
            Trace.WriteLine("button30_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.ECLAMP == "YELO" )
            {
                button30.BackColor = Color.LightGray;
                gv.ECLAMP = "GRAY";
            }
            else
            {
                button30.BackColor = Color.Yellow;
                gv.ECLAMP = "YELO";
            }
        }

        private void button20_Click(object sender, EventArgs e)//MIRROR
        {
            Trace.WriteLine("button20_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.MIRROR == "YELO" )
            {
                button20.BackColor = Color.LightGray;
                gv.MIRROR = "GRAY";
            }
            else
            {
                button20.BackColor = Color.Yellow;
                gv.MIRROR = "YELO";
            }
        }

        private void button22_Click(object sender, EventArgs e)// R2LAMPS
        {
            Trace.WriteLine("button22_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.R2LAMPS == "YELO" )
            {
                button22.BackColor = Color.LightGray;
                gv.R2LAMPS = "GRAY";
            }
            else
            {
                button22.BackColor = Color.Yellow;
                gv.R2LAMPS = "YELO";
            }
        }

        private void button24_Click(object sender, EventArgs e)// R2LAMPS2_H
        {
            Trace.WriteLine("button24_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.R2LAMPS2_H == "YELO" )
            {
                button24.BackColor = Color.LightGray;
                gv.R2LAMPS2_H = "GRAY";
            }
            else
            {
                button24.BackColor = Color.Yellow;
                gv.R2LAMPS2_H = "YELO";
            }
        }

        private void button7_Click(object sender, EventArgs e)// LSLAMP
        {
            Trace.WriteLine("button7_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.LSLAMP == "YELO" )
            {
                button7.BackColor = Color.LightGray;
                gv.LSLAMP = "GRAY";
            }
            else
            {
                button7.BackColor = Color.Yellow;
                gv.LSLAMP = "YELO";
            }
        }

        private void button43_Click(object sender, EventArgs e)// RSLAMP
        {
            Trace.WriteLine("button43_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.RSLAMP == "YELO" )
            {
                button43.BackColor = Color.LightGray;
                gv.RSLAMP = "GRAY";
            }
            else
            {
                button43.BackColor = Color.Yellow;
                gv.RSLAMP = "YELO";
            }
        }

        private void button31_Click(object sender, EventArgs e) // R2LAMPC
        {
            Trace.WriteLine("button31_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.R2LAMPC == "YELO" )
            {
                button31.BackColor = Color.LightGray;
                gv.R2LAMPC = "GRAY";
            }
            else
            {
                button31.BackColor = Color.Yellow;
                gv.R2LAMPC = "YELO";
            }
        }

        private void button33_Click(object sender, EventArgs e)// R2LAMPS2
        {
            Trace.WriteLine("button33_Click()");
            gv.Manifest = "MANUAL ENTRY";

            if ( gv.R2LAMPS2 == "YELO" )
            {
                button33.BackColor = Color.LightGray;
                gv.R2LAMPS2 = "GRAY";
            }
            else
            {
                button33.BackColor = Color.Yellow;
                gv.R2LAMPS2 = "YELO";
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            Trace.WriteLine("button1_Click()");
            gv.Manifest = "MANUAL ENTRY";

            buttonBCMLIN5.BackColor = Color.LightGray;
            button13.BackColor = Color.LightGray;
            button28.BackColor = Color.LightGray;
            button5.BackColor = Color.LightGray;
            button27.BackColor = Color.LightGray;
            button30.BackColor = Color.LightGray;
            button20.BackColor = Color.LightGray;
            button22.BackColor = Color.LightGray;
            button24.BackColor = Color.LightGray;
            button7.BackColor = Color.LightGray;
            button43.BackColor = Color.LightGray;
            button31.BackColor = Color.LightGray;
            button33.BackColor = Color.LightGray;
        }

        private void SetupTestingPerManifest()
        {
            Trace.WriteLine("BEGIN SetupTestingPerManifest()");
            Trace.Indent();

            Trace.WriteLine(Manifest_Options.Text);
            // ******************************************
            // ********* MOD codes per Option ***********
            // ******************************************

            if (Manifest_Options.Text.Contains(",201,")) // Search Manifest for Modcode <<<< 201 THROUGH 205 >>>> (Cell Phone MIC LEFT ??) ???????????????????
            {
                Trace.WriteLine("Manifest contains 201");
                button13.BackColor = Color.Yellow;
            }
            else
            {
                button13.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",301,")) // Search Manifest for Modcode <<<< 301 through 307 >>>> (Other MIC RIGHT ??) ??????????????????????
            {
                Trace.WriteLine("Manifest contains 301");
                button28.BackColor = Color.Yellow;
            }
            else
            {
                button28.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",1801,")) // Search Manifest for Modcode (Noise Cancel MIC)
            {
                Trace.WriteLine("Manifest contains 1801");
                button5.BackColor = Color.Yellow;
            }
            else
            {
                button5.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",601,")) // Search Manifest for Modcode (STOP LAMP) (HARNESS MOD CODE 601-630 ???) ???????????????????????
            {
                Trace.WriteLine("Manifest contains 601");
                button27.BackColor = Color.Yellow;
            }
            else
            {
                button27.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",602,")) // Search Manifest for Modcode (EXT. COURTESY LAMP) (HARNESS MOD CODE 601-630 ???) ???????????????????????
            {
                Trace.WriteLine("Manifest contains 602");
                button30.BackColor = Color.Yellow;
            }
            else
            {
                button30.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",603,")) // Search Manifest for Modcode (BCM LIN 5) (HARNESS MOD CODE 601-630 ???) ???????????????????????
            {
                Trace.WriteLine("Manifest contains 603");
                buttonBCMLIN5.BackColor = Color.Yellow;
            }
            else
            {
                buttonBCMLIN5.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",604,")) // Search Manifest for Modcode (DAY NIGHT MIRROR) (HARNESS MOD CODE 601-630 ???) ???????????????????????
            {
                Trace.WriteLine("Manifest contains 604");
                button20.BackColor = Color.Yellow;
            }
            else
            {
                button20.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",501,")) // Search Manifest for Modcode <<<< 501 TO 510 >>>> (R2 DOME LAMP SWITCH) ??????????????
            {
                Trace.WriteLine("Manifest contains 501");
                button22.BackColor = Color.Yellow;
            }
            else
            {
                button22.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",501,")) // Search Manifest for Modcode <<<< 501 TO 510 >>>> (R2 DOME LAMP SWITCH 2) ??????????????
            {
                Trace.WriteLine("Manifest contains 501");
                button24.BackColor = Color.Yellow;
            }
            else
            {
                button24.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",801,")) // Search Manifest for Modcode <<<< 801 TO 830 >>>> (LEFT SUNSHADE LAMP) ??????????????
            {
                Trace.WriteLine("Manifest contains 801");
                button7.BackColor = Color.Yellow;
            }
            else
            {
                button7.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",901,")) // Search Manifest for Modcode <<<< 901 TO 930 >>>> (RIGHT SUNSHADE LAMP) ??????????????
            {
                Trace.WriteLine("Manifest contains 901");
                button43.BackColor = Color.Yellow;
            }
            else
            {
                button43.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",501,")) // Search Manifest for Modcode <<<< 501 TO 510 >>>> (R2 DOME LAMP CONTROL) ??????????????
            {
                Trace.WriteLine("Manifest contains 501");
                button31.BackColor = Color.Yellow;
                button33.BackColor = Color.Yellow;
            }
            else
            {
                button31.BackColor = Color.LightGray;
                button33.BackColor = Color.LightGray;
            }
            Trace.WriteLine("END SetupTestingPerManifest()");
        }

        private void buttonHighlineManifest_Click(object sender, EventArgs e)
        {
            Trace.WriteLine("buttonHighlineManifest_Click()");
            // HEADLINER MANIFEST - Highline
            Manifest_Options.Text = ""; // Clear Screen
            Manifest_Options.Text = "0000000355149,103xxxxxxxxxx,0000004364960,84874628FT28,501,84810967M38A,201,84793091FT29,301,84660808A28B,901,????????????,601,????????????,602,????????????,603,????????????,604,85116495M40P,601,846608188A28A,801,84798058FW80,1801,";

            // PARSE OUT THE CSN #
            gv.VIN = Manifest_Options.Text.Substring(28, 13);
            textBoxfrm5VIN.Text = gv.VIN;
            SetupTestingPerManifest();
        }

        private void buttonMidlineManifest_Click(object sender, EventArgs e)
        {
            Trace.WriteLine("buttonMidlineManifest_Click()");
            // CONSOLE MANIFEST - Midline
            Manifest_Options.Text = ""; // Clear Screen
            Manifest_Options.Text = "0000000355149,103xxxxxxxxxx,0000004364960,84874628FT28,501,84660808A28B,901,????????????,601,????????????,602,????????????,603,????????????,604,85116495M40P,601,846608188A28A,801,";

            // PARSE OUT THE CSN #
            gv.VIN = Manifest_Options.Text.Substring(28, 13);
            textBoxfrm5VIN.Text = gv.VIN;
            SetupTestingPerManifest();
        }

        private void buttonBaselineManifest_Click(object sender, EventArgs e)
        {
            Trace.WriteLine("buttonBaselineManifest_Click()");
            // CONSOLE MANIFEST - Baseline (default)
            Manifest_Options.Text = ""; // Clear Screen
            Manifest_Options.Text = "0000000355149,103xxxxxxxxxx,0000004364960,????????????,601,????????????,602,????????????,603,";

            // PARSE OUT THE CSN #
            gv.VIN = Manifest_Options.Text.Substring(28, 13);
            textBoxfrm5VIN.Text = gv.VIN;
            SetupTestingPerManifest();
        }

        private void buttonAcceptFailures_Click(object sender, EventArgs e)
        {
            Trace.WriteLine("buttonAcceptFailures_Click()");
            timer1.Stop();
            PLC.SendTestFailed();
            //Form4 frm4 = new Form4();
            gv.HeadlinerConnectTestForm.Show();
        }

        private void timerReadyHeartbeat_Tick(object sender, EventArgs e)
        {

        }
    }
}