#define TRACE
using Sharp7;
using System;
using System.Text;
using System.Diagnostics;

namespace Sample1
{
    #region [Library Functions]

    public static class ArrayFrom
    {
        public static Byte[] Slice(Byte[] FromArray, int Offset, int Length)
        {
            Byte[] Result = new Byte[Length];
            Array.Copy(FromArray, Offset, Result, 0, Length);
            return Result;
        }
    }

    public static class StrFrom
    {
        public static String ThoseBytes(Byte[] FromArray, int Offset, int Length)
        {
            Byte[] Buffer = ArrayFrom.Slice(FromArray, Offset, Length);
            return Encoding.ASCII.GetString(Buffer, 0, Length);
        }
    }

    public static class BoolFrom
    {
        public static bool Bit(Byte FromByte, int iBit)
        {
            return ((FromByte >> iBit) & 1) != 0;
        }
    }
    #endregion [Library Functions]

    #region [PLC Access Wrapper (read/write data from/to PLC)]
    public class PLC
    {
        private const int S7DBNumber = 61;
        private static S7Client Client = new S7Client();

        private static int OffsetudtContinuityTesterOut = 0;

        private static bool fPLCatETC_lab = false;
        private static string fPLC_IPAddress = "10.11.51.50";

        public class aTestResult
        {
            private byte[] faTestResultBuffer = new byte[82];

            public string ModCode { get => S7.GetStringAt(faTestResultBuffer, 0); set => S7.SetStringAt(faTestResultBuffer, 0, 4, value); }
            public string ChannelName { get => S7.GetStringAt(faTestResultBuffer, 6); set => S7.SetStringAt(faTestResultBuffer, 6, 20, value); }
            public string Result { get => S7.GetStringAt(faTestResultBuffer, 0); set => S7.SetStringAt(faTestResultBuffer, 28, 4, value); }
            public string DataVoltsDC { get => S7.GetStringAt(faTestResultBuffer, 0); set => S7.SetStringAt(faTestResultBuffer, 34, 5, value); }
            public int PassVoltageLimit { get => S7.GetDIntAt(faTestResultBuffer, 41); set => S7.SetDIntAt(faTestResultBuffer, 41, value); }
            public int FailVoltageLimit { get => S7.GetDIntAt(faTestResultBuffer, 45); set => S7.SetDIntAt(faTestResultBuffer, 45, value); }
            public string ResultsComments { get => S7.GetStringAt(faTestResultBuffer, 0); set => S7.SetStringAt(faTestResultBuffer, 49, 30, value); }
        }

        public static class Results
        {
            private static byte[] fResultBuffer = new byte[1011];
            private static aTestResult[] fTest = new aTestResult[10];

            public static string TesterName                 { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +   6); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +   6, 13, value); }
            public static string TestDate                   { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  22); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  22, 10, value); }
            public static string CycleStartTimeStamp        { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  34); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  34,  8, value); }
            public static string CycleCompleteTimeStamp     { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  44); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  44,  8, value); }
            public static string TotalCycleTime             { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  54); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  54,  4, value); }
            public static string BuildID                    { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  60); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  60, 13, value); }
            public static string CSN                        { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  76); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  76, 13, value); }
            public static string WCMModuleModCode           { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  92); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  92,  4, value); }
            public static string WCMBaseModelPN             { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  98); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut +  98,  8, value); }
            public static string WCMEndModePN               { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 108); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 108,  8, value); }
            public static string WCMBootLoaderPN            { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 118); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 118,  8, value); }
            public static string WCMApplicationSWID         { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 128); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 128, 10, value); }
            public static string WCMApplicationDataID       { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 140); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 140, 10, value); }
            public static string SIBModuleModCode           { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 152); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 152,  4, value); }
            public static string SIBBaseModelPN             { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 158); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 158,  8, value); }
            public static string EOCMModuleModCode          { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 168); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 168,  4, value); }
            public static string EOCMBaseModelPN            { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 174); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 174,  8, value); }
            public static string EOCMEndModePN              { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 184); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 184,  8, value); }
            public static string EOCMBootLoaderPN           { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 194); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 194,  8, value); }
            public static string EOCMApplicationSWID        { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 204); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 204, 10, value); }
            public static string EOCMApplicationDataID      { get => S7.GetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 216); set => S7.SetStringAt(fResultBuffer, OffsetudtContinuityTesterOut + 216, 10, value); }
            public static aTestResult[] TEST { get => fTest; set => fTest = value; }

            public static byte[] ResultBuffer { get => fResultBuffer; set => fResultBuffer = value; }
        }

        public static void UpdateResultsToPLC()
        {
            Trace.WriteLine("PLC - Writing Results");
            Client.ConnectTo(fPLC_IPAddress, 0, 0);
            if (Client.Connected) Client.DBWrite(S7DBNumber, 0, PLC.Results.ResultBuffer.Length, PLC.Results.ResultBuffer);
        }

        public static string PLC_IPAddress { get => fPLC_IPAddress; set => fPLC_IPAddress = value; }
        
        public static bool bPLCReady()
        {
            return Client.ConnectTo(fPLC_IPAddress, 0, 0) == 0 ? true : false;
        }


        public String GetManifest()
        {
            Trace.WriteLine("PLC - Reading Manifest @ offset 2");
            Byte[] Buffer = new Byte[1001];
            Client.ConnectTo(fPLC_IPAddress, 0, 0);
            if (Client.Connected)
                Client.DBRead(S7DBNumber, 2, Buffer.Length, Buffer);
            else
            {
                Trace.WriteLine("PLC - ERROR: Couldn't connect to PLC, using dummy Manifest");
                Buffer = Encoding.ASCII.GetBytes("0000000355149,103xxxxxxxxxx,0000004364960,13525890FT12,1502,13529874FW86,3002,13529875FW85,4301,135619101FT06,402,13592451FT45,1302,85117464FT09,1101,84638621GO2A,2701,13592452FW74,3501,84952174FW83,4201,84786104FW68,3101,84960563M33V,3301,13537143M08L,2901,");
            }

            return Encoding.ASCII.GetString(Buffer, 0, Buffer.Length);
        }      

        public static void SendTesterReady()
        {
            Trace.WriteLine("PLC - Sending TesterReady @ 1004 bit 1=1");
            byte[] data = new byte[1];
            Client.ConnectTo(fPLC_IPAddress, 0, 0);
            if (Client.Connected)
            {
                Client.DBRead(S7DBNumber, 1004, 1, data);
                S7.SetBitAt(ref data, 0, 0, true);
                Client.DBWrite(S7DBNumber, 1004, 1, data);
            }
        }
        public static void Heartbeat() // may need to throttle heartbeat speed
        {
            byte[] data = new byte[1];
            Client.ConnectTo(fPLC_IPAddress, 0, 0);
            if (Client.Connected)
            {
                Client.DBRead(S7DBNumber, 1004, 1, data);
                S7.SetBitAt(ref data, 0, 1, !S7.GetBitAt(data, 0, 1));
                Client.DBWrite(S7DBNumber, 1004, 1, data);
            }
        }
       
        public static void SendTestPassed()
        {
            Trace.WriteLine("PLC - Sending Test PASS @ 1004 bit 2=1");
            byte[] data = new byte[1];
            Client.ConnectTo(fPLC_IPAddress, 0, 0);
            if (Client.Connected)
            {
                Client.DBRead(S7DBNumber, 1004, 1, data);
                S7.SetBitAt(ref data, 0, 2, true);
                Client.DBWrite(S7DBNumber, 1004, 1, data);
            }
            SendTestComplete();
        }

        public static void SendTestFailed()
        {
            Trace.WriteLine("PLC - Sending Test FAIL @ 1004 bit 3=1");
            byte[] data = new byte[1];
            Client.ConnectTo(fPLC_IPAddress, 0, 0);
            if (Client.Connected)
            {
                Client.DBRead(S7DBNumber, 1004, 1, data);
                S7.SetBitAt(ref data, 0, 3, true);
                Client.DBWrite(S7DBNumber, 1004, 1, data);
            }
            SendTestComplete();
        }

        public static void SendTestComplete()
        {
            Trace.WriteLine("PLC - Sending Test COMPLETE @ 1004 bit 4=1");
            UpdateResultsToPLC();
            byte[] data = new byte[1];
            Client.ConnectTo(fPLC_IPAddress, 0, 0);
            if (Client.Connected)
            {
                Client.DBRead(S7DBNumber, 1004, 1, data);
                S7.SetBitAt(ref data, 0, 4, true);
                Client.DBWrite(S7DBNumber, 1004, 1, data);
            }
        }

        public static bool bGetStart()
        {
            Byte[] Buffer = new Byte[1];
            Client.ConnectTo(fPLC_IPAddress, 0, 0);
            if (Client.Connected)
            {
                Client.DBRead(S7DBNumber, 0, Buffer.Length, Buffer);
            }
            return (Buffer[0] & 1) != 0;
        }

        public void WriteManifest(in byte[] buffer)
        {
            Trace.WriteLine("PLC - DEBUG: Writing manifest @ 2");
            Client.ConnectTo(fPLC_IPAddress, 0, 0);
            if (Client.Connected)
                Client.DBWrite(S7DBNumber, 2, buffer.Length, buffer);
        }

        public bool bPLCAtETC
        {
            get => fPLCatETC_lab;
            set
            {
                fPLCatETC_lab = value;
                if (value)
                    OffsetudtContinuityTesterOut = 0;
                else
                    OffsetudtContinuityTesterOut = 1004;
            }
        }
    }

    #endregion [PLC Readback Wrapper]

}